Argus API Argus Camera API

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
EventProvider.h
Go to the documentation of this file.
1 /*
2 * Copyright (c) 2016, NVIDIA CORPORATION. All rights reserved.
3 *
4 * Redistribution and use in source and binary forms, with or without
5 * modification, are permitted provided that the following conditions
6 * are met:
7 * * Redistributions of source code must retain the above copyright
8 * notice, this list of conditions and the following disclaimer.
9 * * Redistributions in binary form must reproduce the above copyright
10 * notice, this list of conditions and the following disclaimer in the
11 * documentation and/or other materials provided with the distribution.
12 * * Neither the name of NVIDIA CORPORATION nor the names of its
13 * contributors may be used to endorse or promote products derived
14 * from this software without specific prior written permission.
15 *
16 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
17 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
19 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
20 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
21 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
22 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
23 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
24 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
25 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
26 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
27 */
28
29 #ifndef _ARGUS_EVENT_PROVIDER_H
30 #define _ARGUS_EVENT_PROVIDER_H
31
32 namespace Argus
33 {
34
35 /**
36 * @class IEventProvider
37 *
38 * The interface for an object which generates Events (such as CaptureSession).
39 * Any generated Events are initially stored by the provider itself, and they
40 * are not copied out to public EventQueues until waitForEvents() is called.
41 * If at any time there is an event type offered by a provider that is not
42 * accepted by an active EventQueue created by that provider, all events of
43 * that type will be discarded.
44 */
45 DEFINE_UUID(InterfaceID, IID_EVENT_PROVIDER, 523ed330,25dc,11e5,867f,08,00,20,0c,9a,66);
46
47 class IEventProvider : public Interface
48 {
49 public:
50 static const InterfaceID& id() { return IID_EVENT_PROVIDER; }
51
52 /**
53 * Returns a list of event types that this provider can generate.
54 * @param[out] types, a vector that will be populated by the available event types.
55 *
56 * @returns success/status of the call.
57 */
58 virtual Status getAvailableEventTypes(std::vector<EventType>* types) const = 0;
59
60 /**
61 * Creates an event queue for events of the given type(s)
62 * @param[in] eventTypes The list of event types for the queue.
63 * @param[out] status An optional pointer to return success/status.
64 *
65 * @returns the new EventQueue object, or NULL on failure.
66 */
67 virtual EventQueue* createEventQueue(const std::vector<EventType>& eventTypes,
68 Status* status = NULL) = 0;
69
70 /**
71 * Waits for and transfers any pending events from the provider to the
72 * provided queues.
73 *
74 * Ownership of all events transfered to a queue will be passed from the
75 * provider to the queue, and these event object pointers will remain
76 * valid until the queue is destroyed or until the next call to this
77 * function with that queue. In other words, any events in a queue will be
78 * destroyed when the queue is provided to another call of this function,
79 * regardless of whether or not it receives any new events, or when the
80 * queue is destroyed.
81 *
82 * If more than one given queue accepts events of the same type, only the
83 * first of these queues will receive events of that type.
84 *
85 * Any events that are not copied to queues by this function are left in
86 * the provider until they are queried using a queue receiving events of
87 * that type.
88 *
89 * If there are no pending events of the requested types at the time this
90 * function is called, it will block until one is available or a timeout
91 * occurs.
92 *
93 * @param[in] queues The list of queues to transfer events to.
94 * @param[in] timeout The maximum time (in nanoseconds) to wait for new events.
95 *
96 * @returns success/status of the call.
97 */
98 virtual Status waitForEvents(const std::vector<EventQueue*>& queues,
99 uint64_t timeout = TIMEOUT_INFINITE) = 0;
100
101 /**
102 * Variant of waitForEvents() that waits for only one EventQueue.
103 */
104 virtual Status waitForEvents(EventQueue* queue,
105 uint64_t timeout = TIMEOUT_INFINITE) = 0;
106
107 protected:
108 ~IEventProvider() {}
109 };
110
111 } // namespace Argus
112
113 #endif // _ARGUS_EVENT_PROVIDER_H